//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private _Jurbol_TDI_DSMA[] cache_Jurbol_TDI_DSMA = null;
        private _Jurbol_TDI_V1[] cache_Jurbol_TDI_V1 = null;
        private _Jurbol_TDI_V1_Hist[] cache_Jurbol_TDI_V1_Hist = null;

        private static _Jurbol_TDI_DSMA check_Jurbol_TDI_DSMA = new _Jurbol_TDI_DSMA();
        private static _Jurbol_TDI_V1 check_Jurbol_TDI_V1 = new _Jurbol_TDI_V1();
        private static _Jurbol_TDI_V1_Hist check_Jurbol_TDI_V1_Hist = new _Jurbol_TDI_V1_Hist();

        /// <summary>
        /// Displaced SMA indicators with colorcoded close above/below the DSMA. Selectable priceline also included.
        /// </summary>
        /// <returns></returns>
        public _Jurbol_TDI_DSMA _Jurbol_TDI_DSMA(bool colors, int displace, Color dn, Color lineColorBear, Color lineColorBull, Color lineColorFlat, DashStyle lineStyle, int period, bool priceLine, int rayLength, Color up)
        {
            return _Jurbol_TDI_DSMA(Input, colors, displace, dn, lineColorBear, lineColorBull, lineColorFlat, lineStyle, period, priceLine, rayLength, up);
        }

        /// <summary>
        /// Displaced SMA indicators with colorcoded close above/below the DSMA. Selectable priceline also included.
        /// </summary>
        /// <returns></returns>
        public _Jurbol_TDI_DSMA _Jurbol_TDI_DSMA(Data.IDataSeries input, bool colors, int displace, Color dn, Color lineColorBear, Color lineColorBull, Color lineColorFlat, DashStyle lineStyle, int period, bool priceLine, int rayLength, Color up)
        {
            if (cache_Jurbol_TDI_DSMA != null)
                for (int idx = 0; idx < cache_Jurbol_TDI_DSMA.Length; idx++)
                    if (cache_Jurbol_TDI_DSMA[idx].Colors == colors && cache_Jurbol_TDI_DSMA[idx].Displace == displace && cache_Jurbol_TDI_DSMA[idx].Dn == dn && cache_Jurbol_TDI_DSMA[idx].LineColorBear == lineColorBear && cache_Jurbol_TDI_DSMA[idx].LineColorBull == lineColorBull && cache_Jurbol_TDI_DSMA[idx].LineColorFlat == lineColorFlat && cache_Jurbol_TDI_DSMA[idx].LineStyle == lineStyle && cache_Jurbol_TDI_DSMA[idx].Period == period && cache_Jurbol_TDI_DSMA[idx].PriceLine == priceLine && cache_Jurbol_TDI_DSMA[idx].RayLength == rayLength && cache_Jurbol_TDI_DSMA[idx].Up == up && cache_Jurbol_TDI_DSMA[idx].EqualsInput(input))
                        return cache_Jurbol_TDI_DSMA[idx];

            lock (check_Jurbol_TDI_DSMA)
            {
                check_Jurbol_TDI_DSMA.Colors = colors;
                colors = check_Jurbol_TDI_DSMA.Colors;
                check_Jurbol_TDI_DSMA.Displace = displace;
                displace = check_Jurbol_TDI_DSMA.Displace;
                check_Jurbol_TDI_DSMA.Dn = dn;
                dn = check_Jurbol_TDI_DSMA.Dn;
                check_Jurbol_TDI_DSMA.LineColorBear = lineColorBear;
                lineColorBear = check_Jurbol_TDI_DSMA.LineColorBear;
                check_Jurbol_TDI_DSMA.LineColorBull = lineColorBull;
                lineColorBull = check_Jurbol_TDI_DSMA.LineColorBull;
                check_Jurbol_TDI_DSMA.LineColorFlat = lineColorFlat;
                lineColorFlat = check_Jurbol_TDI_DSMA.LineColorFlat;
                check_Jurbol_TDI_DSMA.LineStyle = lineStyle;
                lineStyle = check_Jurbol_TDI_DSMA.LineStyle;
                check_Jurbol_TDI_DSMA.Period = period;
                period = check_Jurbol_TDI_DSMA.Period;
                check_Jurbol_TDI_DSMA.PriceLine = priceLine;
                priceLine = check_Jurbol_TDI_DSMA.PriceLine;
                check_Jurbol_TDI_DSMA.RayLength = rayLength;
                rayLength = check_Jurbol_TDI_DSMA.RayLength;
                check_Jurbol_TDI_DSMA.Up = up;
                up = check_Jurbol_TDI_DSMA.Up;

                if (cache_Jurbol_TDI_DSMA != null)
                    for (int idx = 0; idx < cache_Jurbol_TDI_DSMA.Length; idx++)
                        if (cache_Jurbol_TDI_DSMA[idx].Colors == colors && cache_Jurbol_TDI_DSMA[idx].Displace == displace && cache_Jurbol_TDI_DSMA[idx].Dn == dn && cache_Jurbol_TDI_DSMA[idx].LineColorBear == lineColorBear && cache_Jurbol_TDI_DSMA[idx].LineColorBull == lineColorBull && cache_Jurbol_TDI_DSMA[idx].LineColorFlat == lineColorFlat && cache_Jurbol_TDI_DSMA[idx].LineStyle == lineStyle && cache_Jurbol_TDI_DSMA[idx].Period == period && cache_Jurbol_TDI_DSMA[idx].PriceLine == priceLine && cache_Jurbol_TDI_DSMA[idx].RayLength == rayLength && cache_Jurbol_TDI_DSMA[idx].Up == up && cache_Jurbol_TDI_DSMA[idx].EqualsInput(input))
                            return cache_Jurbol_TDI_DSMA[idx];

                _Jurbol_TDI_DSMA indicator = new _Jurbol_TDI_DSMA();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Colors = colors;
                indicator.Displace = displace;
                indicator.Dn = dn;
                indicator.LineColorBear = lineColorBear;
                indicator.LineColorBull = lineColorBull;
                indicator.LineColorFlat = lineColorFlat;
                indicator.LineStyle = lineStyle;
                indicator.Period = period;
                indicator.PriceLine = priceLine;
                indicator.RayLength = rayLength;
                indicator.Up = up;
                Indicators.Add(indicator);
                indicator.SetUp();

                _Jurbol_TDI_DSMA[] tmp = new _Jurbol_TDI_DSMA[cache_Jurbol_TDI_DSMA == null ? 1 : cache_Jurbol_TDI_DSMA.Length + 1];
                if (cache_Jurbol_TDI_DSMA != null)
                    cache_Jurbol_TDI_DSMA.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cache_Jurbol_TDI_DSMA = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// TDI Indicator. 
        /// </summary>
        /// <returns></returns>
        public _Jurbol_TDI_V1 _Jurbol_TDI_V1(int arrowSize, Color bgDn, Color bgUp, Color bounceDn, Color bounceUp, bool coloredCandles, Color crossDn, Color crossUp, Color dnBar, Color linesBear, Color linesBull, Color nnBar, int offset, bool showBGArrows, bool showBGLines, bool showBounceArrows, bool showBounceLines, bool showCrossArrows, bool showCrossLines, bool showStopLines, bool showStopPips, int stopPlacement, Color upBar)
        {
            return _Jurbol_TDI_V1(Input, arrowSize, bgDn, bgUp, bounceDn, bounceUp, coloredCandles, crossDn, crossUp, dnBar, linesBear, linesBull, nnBar, offset, showBGArrows, showBGLines, showBounceArrows, showBounceLines, showCrossArrows, showCrossLines, showStopLines, showStopPips, stopPlacement, upBar);
        }

        /// <summary>
        /// TDI Indicator. 
        /// </summary>
        /// <returns></returns>
        public _Jurbol_TDI_V1 _Jurbol_TDI_V1(Data.IDataSeries input, int arrowSize, Color bgDn, Color bgUp, Color bounceDn, Color bounceUp, bool coloredCandles, Color crossDn, Color crossUp, Color dnBar, Color linesBear, Color linesBull, Color nnBar, int offset, bool showBGArrows, bool showBGLines, bool showBounceArrows, bool showBounceLines, bool showCrossArrows, bool showCrossLines, bool showStopLines, bool showStopPips, int stopPlacement, Color upBar)
        {
            if (cache_Jurbol_TDI_V1 != null)
                for (int idx = 0; idx < cache_Jurbol_TDI_V1.Length; idx++)
                    if (cache_Jurbol_TDI_V1[idx].ArrowSize == arrowSize && cache_Jurbol_TDI_V1[idx].BgDn == bgDn && cache_Jurbol_TDI_V1[idx].BgUp == bgUp && cache_Jurbol_TDI_V1[idx].BounceDn == bounceDn && cache_Jurbol_TDI_V1[idx].BounceUp == bounceUp && cache_Jurbol_TDI_V1[idx].ColoredCandles == coloredCandles && cache_Jurbol_TDI_V1[idx].CrossDn == crossDn && cache_Jurbol_TDI_V1[idx].CrossUp == crossUp && cache_Jurbol_TDI_V1[idx].DnBar == dnBar && cache_Jurbol_TDI_V1[idx].LinesBear == linesBear && cache_Jurbol_TDI_V1[idx].LinesBull == linesBull && cache_Jurbol_TDI_V1[idx].NnBar == nnBar && cache_Jurbol_TDI_V1[idx].Offset == offset && cache_Jurbol_TDI_V1[idx].ShowBGArrows == showBGArrows && cache_Jurbol_TDI_V1[idx].ShowBGLines == showBGLines && cache_Jurbol_TDI_V1[idx].ShowBounceArrows == showBounceArrows && cache_Jurbol_TDI_V1[idx].ShowBounceLines == showBounceLines && cache_Jurbol_TDI_V1[idx].ShowCrossArrows == showCrossArrows && cache_Jurbol_TDI_V1[idx].ShowCrossLines == showCrossLines && cache_Jurbol_TDI_V1[idx].ShowStopLines == showStopLines && cache_Jurbol_TDI_V1[idx].ShowStopPips == showStopPips && cache_Jurbol_TDI_V1[idx].StopPlacement == stopPlacement && cache_Jurbol_TDI_V1[idx].UpBar == upBar && cache_Jurbol_TDI_V1[idx].EqualsInput(input))
                        return cache_Jurbol_TDI_V1[idx];

            lock (check_Jurbol_TDI_V1)
            {
                check_Jurbol_TDI_V1.ArrowSize = arrowSize;
                arrowSize = check_Jurbol_TDI_V1.ArrowSize;
                check_Jurbol_TDI_V1.BgDn = bgDn;
                bgDn = check_Jurbol_TDI_V1.BgDn;
                check_Jurbol_TDI_V1.BgUp = bgUp;
                bgUp = check_Jurbol_TDI_V1.BgUp;
                check_Jurbol_TDI_V1.BounceDn = bounceDn;
                bounceDn = check_Jurbol_TDI_V1.BounceDn;
                check_Jurbol_TDI_V1.BounceUp = bounceUp;
                bounceUp = check_Jurbol_TDI_V1.BounceUp;
                check_Jurbol_TDI_V1.ColoredCandles = coloredCandles;
                coloredCandles = check_Jurbol_TDI_V1.ColoredCandles;
                check_Jurbol_TDI_V1.CrossDn = crossDn;
                crossDn = check_Jurbol_TDI_V1.CrossDn;
                check_Jurbol_TDI_V1.CrossUp = crossUp;
                crossUp = check_Jurbol_TDI_V1.CrossUp;
                check_Jurbol_TDI_V1.DnBar = dnBar;
                dnBar = check_Jurbol_TDI_V1.DnBar;
                check_Jurbol_TDI_V1.LinesBear = linesBear;
                linesBear = check_Jurbol_TDI_V1.LinesBear;
                check_Jurbol_TDI_V1.LinesBull = linesBull;
                linesBull = check_Jurbol_TDI_V1.LinesBull;
                check_Jurbol_TDI_V1.NnBar = nnBar;
                nnBar = check_Jurbol_TDI_V1.NnBar;
                check_Jurbol_TDI_V1.Offset = offset;
                offset = check_Jurbol_TDI_V1.Offset;
                check_Jurbol_TDI_V1.ShowBGArrows = showBGArrows;
                showBGArrows = check_Jurbol_TDI_V1.ShowBGArrows;
                check_Jurbol_TDI_V1.ShowBGLines = showBGLines;
                showBGLines = check_Jurbol_TDI_V1.ShowBGLines;
                check_Jurbol_TDI_V1.ShowBounceArrows = showBounceArrows;
                showBounceArrows = check_Jurbol_TDI_V1.ShowBounceArrows;
                check_Jurbol_TDI_V1.ShowBounceLines = showBounceLines;
                showBounceLines = check_Jurbol_TDI_V1.ShowBounceLines;
                check_Jurbol_TDI_V1.ShowCrossArrows = showCrossArrows;
                showCrossArrows = check_Jurbol_TDI_V1.ShowCrossArrows;
                check_Jurbol_TDI_V1.ShowCrossLines = showCrossLines;
                showCrossLines = check_Jurbol_TDI_V1.ShowCrossLines;
                check_Jurbol_TDI_V1.ShowStopLines = showStopLines;
                showStopLines = check_Jurbol_TDI_V1.ShowStopLines;
                check_Jurbol_TDI_V1.ShowStopPips = showStopPips;
                showStopPips = check_Jurbol_TDI_V1.ShowStopPips;
                check_Jurbol_TDI_V1.StopPlacement = stopPlacement;
                stopPlacement = check_Jurbol_TDI_V1.StopPlacement;
                check_Jurbol_TDI_V1.UpBar = upBar;
                upBar = check_Jurbol_TDI_V1.UpBar;

                if (cache_Jurbol_TDI_V1 != null)
                    for (int idx = 0; idx < cache_Jurbol_TDI_V1.Length; idx++)
                        if (cache_Jurbol_TDI_V1[idx].ArrowSize == arrowSize && cache_Jurbol_TDI_V1[idx].BgDn == bgDn && cache_Jurbol_TDI_V1[idx].BgUp == bgUp && cache_Jurbol_TDI_V1[idx].BounceDn == bounceDn && cache_Jurbol_TDI_V1[idx].BounceUp == bounceUp && cache_Jurbol_TDI_V1[idx].ColoredCandles == coloredCandles && cache_Jurbol_TDI_V1[idx].CrossDn == crossDn && cache_Jurbol_TDI_V1[idx].CrossUp == crossUp && cache_Jurbol_TDI_V1[idx].DnBar == dnBar && cache_Jurbol_TDI_V1[idx].LinesBear == linesBear && cache_Jurbol_TDI_V1[idx].LinesBull == linesBull && cache_Jurbol_TDI_V1[idx].NnBar == nnBar && cache_Jurbol_TDI_V1[idx].Offset == offset && cache_Jurbol_TDI_V1[idx].ShowBGArrows == showBGArrows && cache_Jurbol_TDI_V1[idx].ShowBGLines == showBGLines && cache_Jurbol_TDI_V1[idx].ShowBounceArrows == showBounceArrows && cache_Jurbol_TDI_V1[idx].ShowBounceLines == showBounceLines && cache_Jurbol_TDI_V1[idx].ShowCrossArrows == showCrossArrows && cache_Jurbol_TDI_V1[idx].ShowCrossLines == showCrossLines && cache_Jurbol_TDI_V1[idx].ShowStopLines == showStopLines && cache_Jurbol_TDI_V1[idx].ShowStopPips == showStopPips && cache_Jurbol_TDI_V1[idx].StopPlacement == stopPlacement && cache_Jurbol_TDI_V1[idx].UpBar == upBar && cache_Jurbol_TDI_V1[idx].EqualsInput(input))
                            return cache_Jurbol_TDI_V1[idx];

                _Jurbol_TDI_V1 indicator = new _Jurbol_TDI_V1();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.ArrowSize = arrowSize;
                indicator.BgDn = bgDn;
                indicator.BgUp = bgUp;
                indicator.BounceDn = bounceDn;
                indicator.BounceUp = bounceUp;
                indicator.ColoredCandles = coloredCandles;
                indicator.CrossDn = crossDn;
                indicator.CrossUp = crossUp;
                indicator.DnBar = dnBar;
                indicator.LinesBear = linesBear;
                indicator.LinesBull = linesBull;
                indicator.NnBar = nnBar;
                indicator.Offset = offset;
                indicator.ShowBGArrows = showBGArrows;
                indicator.ShowBGLines = showBGLines;
                indicator.ShowBounceArrows = showBounceArrows;
                indicator.ShowBounceLines = showBounceLines;
                indicator.ShowCrossArrows = showCrossArrows;
                indicator.ShowCrossLines = showCrossLines;
                indicator.ShowStopLines = showStopLines;
                indicator.ShowStopPips = showStopPips;
                indicator.StopPlacement = stopPlacement;
                indicator.UpBar = upBar;
                Indicators.Add(indicator);
                indicator.SetUp();

                _Jurbol_TDI_V1[] tmp = new _Jurbol_TDI_V1[cache_Jurbol_TDI_V1 == null ? 1 : cache_Jurbol_TDI_V1.Length + 1];
                if (cache_Jurbol_TDI_V1 != null)
                    cache_Jurbol_TDI_V1.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cache_Jurbol_TDI_V1 = tmp;
                return indicator;
            }
        }

        /// <summary>
        /// Histogram view of the _Jurbol_TDI_V1
        /// </summary>
        /// <returns></returns>
        public _Jurbol_TDI_V1_Hist _Jurbol_TDI_V1_Hist(Color dn, Color up)
        {
            return _Jurbol_TDI_V1_Hist(Input, dn, up);
        }

        /// <summary>
        /// Histogram view of the _Jurbol_TDI_V1
        /// </summary>
        /// <returns></returns>
        public _Jurbol_TDI_V1_Hist _Jurbol_TDI_V1_Hist(Data.IDataSeries input, Color dn, Color up)
        {
            if (cache_Jurbol_TDI_V1_Hist != null)
                for (int idx = 0; idx < cache_Jurbol_TDI_V1_Hist.Length; idx++)
                    if (cache_Jurbol_TDI_V1_Hist[idx].Dn == dn && cache_Jurbol_TDI_V1_Hist[idx].Up == up && cache_Jurbol_TDI_V1_Hist[idx].EqualsInput(input))
                        return cache_Jurbol_TDI_V1_Hist[idx];

            lock (check_Jurbol_TDI_V1_Hist)
            {
                check_Jurbol_TDI_V1_Hist.Dn = dn;
                dn = check_Jurbol_TDI_V1_Hist.Dn;
                check_Jurbol_TDI_V1_Hist.Up = up;
                up = check_Jurbol_TDI_V1_Hist.Up;

                if (cache_Jurbol_TDI_V1_Hist != null)
                    for (int idx = 0; idx < cache_Jurbol_TDI_V1_Hist.Length; idx++)
                        if (cache_Jurbol_TDI_V1_Hist[idx].Dn == dn && cache_Jurbol_TDI_V1_Hist[idx].Up == up && cache_Jurbol_TDI_V1_Hist[idx].EqualsInput(input))
                            return cache_Jurbol_TDI_V1_Hist[idx];

                _Jurbol_TDI_V1_Hist indicator = new _Jurbol_TDI_V1_Hist();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Dn = dn;
                indicator.Up = up;
                Indicators.Add(indicator);
                indicator.SetUp();

                _Jurbol_TDI_V1_Hist[] tmp = new _Jurbol_TDI_V1_Hist[cache_Jurbol_TDI_V1_Hist == null ? 1 : cache_Jurbol_TDI_V1_Hist.Length + 1];
                if (cache_Jurbol_TDI_V1_Hist != null)
                    cache_Jurbol_TDI_V1_Hist.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cache_Jurbol_TDI_V1_Hist = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// Displaced SMA indicators with colorcoded close above/below the DSMA. Selectable priceline also included.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator._Jurbol_TDI_DSMA _Jurbol_TDI_DSMA(bool colors, int displace, Color dn, Color lineColorBear, Color lineColorBull, Color lineColorFlat, DashStyle lineStyle, int period, bool priceLine, int rayLength, Color up)
        {
            return _indicator._Jurbol_TDI_DSMA(Input, colors, displace, dn, lineColorBear, lineColorBull, lineColorFlat, lineStyle, period, priceLine, rayLength, up);
        }

        /// <summary>
        /// Displaced SMA indicators with colorcoded close above/below the DSMA. Selectable priceline also included.
        /// </summary>
        /// <returns></returns>
        public Indicator._Jurbol_TDI_DSMA _Jurbol_TDI_DSMA(Data.IDataSeries input, bool colors, int displace, Color dn, Color lineColorBear, Color lineColorBull, Color lineColorFlat, DashStyle lineStyle, int period, bool priceLine, int rayLength, Color up)
        {
            return _indicator._Jurbol_TDI_DSMA(input, colors, displace, dn, lineColorBear, lineColorBull, lineColorFlat, lineStyle, period, priceLine, rayLength, up);
        }

        /// <summary>
        /// TDI Indicator. 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator._Jurbol_TDI_V1 _Jurbol_TDI_V1(int arrowSize, Color bgDn, Color bgUp, Color bounceDn, Color bounceUp, bool coloredCandles, Color crossDn, Color crossUp, Color dnBar, Color linesBear, Color linesBull, Color nnBar, int offset, bool showBGArrows, bool showBGLines, bool showBounceArrows, bool showBounceLines, bool showCrossArrows, bool showCrossLines, bool showStopLines, bool showStopPips, int stopPlacement, Color upBar)
        {
            return _indicator._Jurbol_TDI_V1(Input, arrowSize, bgDn, bgUp, bounceDn, bounceUp, coloredCandles, crossDn, crossUp, dnBar, linesBear, linesBull, nnBar, offset, showBGArrows, showBGLines, showBounceArrows, showBounceLines, showCrossArrows, showCrossLines, showStopLines, showStopPips, stopPlacement, upBar);
        }

        /// <summary>
        /// TDI Indicator. 
        /// </summary>
        /// <returns></returns>
        public Indicator._Jurbol_TDI_V1 _Jurbol_TDI_V1(Data.IDataSeries input, int arrowSize, Color bgDn, Color bgUp, Color bounceDn, Color bounceUp, bool coloredCandles, Color crossDn, Color crossUp, Color dnBar, Color linesBear, Color linesBull, Color nnBar, int offset, bool showBGArrows, bool showBGLines, bool showBounceArrows, bool showBounceLines, bool showCrossArrows, bool showCrossLines, bool showStopLines, bool showStopPips, int stopPlacement, Color upBar)
        {
            return _indicator._Jurbol_TDI_V1(input, arrowSize, bgDn, bgUp, bounceDn, bounceUp, coloredCandles, crossDn, crossUp, dnBar, linesBear, linesBull, nnBar, offset, showBGArrows, showBGLines, showBounceArrows, showBounceLines, showCrossArrows, showCrossLines, showStopLines, showStopPips, stopPlacement, upBar);
        }

        /// <summary>
        /// Histogram view of the _Jurbol_TDI_V1
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator._Jurbol_TDI_V1_Hist _Jurbol_TDI_V1_Hist(Color dn, Color up)
        {
            return _indicator._Jurbol_TDI_V1_Hist(Input, dn, up);
        }

        /// <summary>
        /// Histogram view of the _Jurbol_TDI_V1
        /// </summary>
        /// <returns></returns>
        public Indicator._Jurbol_TDI_V1_Hist _Jurbol_TDI_V1_Hist(Data.IDataSeries input, Color dn, Color up)
        {
            return _indicator._Jurbol_TDI_V1_Hist(input, dn, up);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// Displaced SMA indicators with colorcoded close above/below the DSMA. Selectable priceline also included.
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator._Jurbol_TDI_DSMA _Jurbol_TDI_DSMA(bool colors, int displace, Color dn, Color lineColorBear, Color lineColorBull, Color lineColorFlat, DashStyle lineStyle, int period, bool priceLine, int rayLength, Color up)
        {
            return _indicator._Jurbol_TDI_DSMA(Input, colors, displace, dn, lineColorBear, lineColorBull, lineColorFlat, lineStyle, period, priceLine, rayLength, up);
        }

        /// <summary>
        /// Displaced SMA indicators with colorcoded close above/below the DSMA. Selectable priceline also included.
        /// </summary>
        /// <returns></returns>
        public Indicator._Jurbol_TDI_DSMA _Jurbol_TDI_DSMA(Data.IDataSeries input, bool colors, int displace, Color dn, Color lineColorBear, Color lineColorBull, Color lineColorFlat, DashStyle lineStyle, int period, bool priceLine, int rayLength, Color up)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator._Jurbol_TDI_DSMA(input, colors, displace, dn, lineColorBear, lineColorBull, lineColorFlat, lineStyle, period, priceLine, rayLength, up);
        }

        /// <summary>
        /// TDI Indicator. 
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator._Jurbol_TDI_V1 _Jurbol_TDI_V1(int arrowSize, Color bgDn, Color bgUp, Color bounceDn, Color bounceUp, bool coloredCandles, Color crossDn, Color crossUp, Color dnBar, Color linesBear, Color linesBull, Color nnBar, int offset, bool showBGArrows, bool showBGLines, bool showBounceArrows, bool showBounceLines, bool showCrossArrows, bool showCrossLines, bool showStopLines, bool showStopPips, int stopPlacement, Color upBar)
        {
            return _indicator._Jurbol_TDI_V1(Input, arrowSize, bgDn, bgUp, bounceDn, bounceUp, coloredCandles, crossDn, crossUp, dnBar, linesBear, linesBull, nnBar, offset, showBGArrows, showBGLines, showBounceArrows, showBounceLines, showCrossArrows, showCrossLines, showStopLines, showStopPips, stopPlacement, upBar);
        }

        /// <summary>
        /// TDI Indicator. 
        /// </summary>
        /// <returns></returns>
        public Indicator._Jurbol_TDI_V1 _Jurbol_TDI_V1(Data.IDataSeries input, int arrowSize, Color bgDn, Color bgUp, Color bounceDn, Color bounceUp, bool coloredCandles, Color crossDn, Color crossUp, Color dnBar, Color linesBear, Color linesBull, Color nnBar, int offset, bool showBGArrows, bool showBGLines, bool showBounceArrows, bool showBounceLines, bool showCrossArrows, bool showCrossLines, bool showStopLines, bool showStopPips, int stopPlacement, Color upBar)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator._Jurbol_TDI_V1(input, arrowSize, bgDn, bgUp, bounceDn, bounceUp, coloredCandles, crossDn, crossUp, dnBar, linesBear, linesBull, nnBar, offset, showBGArrows, showBGLines, showBounceArrows, showBounceLines, showCrossArrows, showCrossLines, showStopLines, showStopPips, stopPlacement, upBar);
        }

        /// <summary>
        /// Histogram view of the _Jurbol_TDI_V1
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator._Jurbol_TDI_V1_Hist _Jurbol_TDI_V1_Hist(Color dn, Color up)
        {
            return _indicator._Jurbol_TDI_V1_Hist(Input, dn, up);
        }

        /// <summary>
        /// Histogram view of the _Jurbol_TDI_V1
        /// </summary>
        /// <returns></returns>
        public Indicator._Jurbol_TDI_V1_Hist _Jurbol_TDI_V1_Hist(Data.IDataSeries input, Color dn, Color up)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator._Jurbol_TDI_V1_Hist(input, dn, up);
        }
    }
}
#endregion
